git-clone: honor "--" to end argument parsing
[git/dscho.git] / git-rebase.sh
blob224cca98eea324cabf30885f7c92c254b184410b
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE='[--interactive | -i] [-v] [--onto <newbase>] <upstream> [<branch>]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .dotest working files, use the command
18 git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used. You must be in the top
22 directory of your project to start (or continue) a rebase.
24 Example: git-rebase master~1 topic
26 A---B---C topic A'\''--B'\''--C'\'' topic
27 / --> /
28 D---E---F---G master D---E---F---G master
31 SUBDIRECTORY_OK=Yes
32 . git-sh-setup
33 set_reflog_action rebase
34 require_work_tree
35 cd_to_toplevel
37 RESOLVEMSG="
38 When you have resolved this problem run \"git rebase --continue\".
39 If you would prefer to skip this patch, instead run \"git rebase --skip\".
40 To restore the original branch and stop rebasing run \"git rebase --abort\".
42 unset newbase
43 strategy=recursive
44 do_merge=
45 dotest=$GIT_DIR/.dotest-merge
46 prec=4
47 verbose=
48 git_am_opt=
50 continue_merge () {
51 test -n "$prev_head" || die "prev_head must be defined"
52 test -d "$dotest" || die "$dotest directory does not exist"
54 unmerged=$(git ls-files -u)
55 if test -n "$unmerged"
56 then
57 echo "You still have unmerged paths in your index"
58 echo "did you forget to use git add?"
59 die "$RESOLVEMSG"
62 cmt=`cat "$dotest/current"`
63 if ! git diff-index --quiet HEAD
64 then
65 if ! git-commit -C "$cmt"
66 then
67 echo "Commit failed, please do not call \"git commit\""
68 echo "directly, but instead do one of the following: "
69 die "$RESOLVEMSG"
71 printf "Committed: %0${prec}d " $msgnum
72 else
73 printf "Already applied: %0${prec}d " $msgnum
75 git rev-list --pretty=oneline -1 "$cmt" | sed -e 's/^[^ ]* //'
77 prev_head=`git rev-parse HEAD^0`
78 # save the resulting commit so we can read-tree on it later
79 echo "$prev_head" > "$dotest/prev_head"
81 # onto the next patch:
82 msgnum=$(($msgnum + 1))
83 echo "$msgnum" >"$dotest/msgnum"
86 call_merge () {
87 cmt="$(cat "$dotest/cmt.$1")"
88 echo "$cmt" > "$dotest/current"
89 hd=$(git rev-parse --verify HEAD)
90 cmt_name=$(git symbolic-ref HEAD)
91 msgnum=$(cat "$dotest/msgnum")
92 end=$(cat "$dotest/end")
93 eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
94 eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
95 export GITHEAD_$cmt GITHEAD_$hd
96 git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
97 rv=$?
98 case "$rv" in
100 unset GITHEAD_$cmt GITHEAD_$hd
101 return
104 git rerere
105 die "$RESOLVEMSG"
108 echo "Strategy: $rv $strategy failed, try another" 1>&2
109 die "$RESOLVEMSG"
112 die "Unknown exit code ($rv) from command:" \
113 "git-merge-$strategy $cmt^ -- HEAD $cmt"
115 esac
118 finish_rb_merge () {
119 rm -r "$dotest"
120 echo "All done."
123 is_interactive () {
124 test -f "$dotest"/interactive ||
125 while :; do case $#,"$1" in 0,|*,-i|*,--interactive) break ;; esac
126 shift
127 done && test -n "$1"
130 is_interactive "$@" && exec git-rebase--interactive "$@"
132 while test $# != 0
134 case "$1" in
135 --continue)
136 git diff-files --quiet || {
137 echo "You must edit all merge conflicts and then"
138 echo "mark them as resolved using git add"
139 exit 1
141 if test -d "$dotest"
142 then
143 prev_head=$(cat "$dotest/prev_head")
144 end=$(cat "$dotest/end")
145 msgnum=$(cat "$dotest/msgnum")
146 onto=$(cat "$dotest/onto")
147 continue_merge
148 while test "$msgnum" -le "$end"
150 call_merge "$msgnum"
151 continue_merge
152 done
153 finish_rb_merge
154 exit
156 git am --resolved --3way --resolvemsg="$RESOLVEMSG"
157 exit
159 --skip)
160 if test -d "$dotest"
161 then
162 git rerere clear
163 prev_head=$(cat "$dotest/prev_head")
164 end=$(cat "$dotest/end")
165 msgnum=$(cat "$dotest/msgnum")
166 msgnum=$(($msgnum + 1))
167 onto=$(cat "$dotest/onto")
168 while test "$msgnum" -le "$end"
170 call_merge "$msgnum"
171 continue_merge
172 done
173 finish_rb_merge
174 exit
176 git am -3 --skip --resolvemsg="$RESOLVEMSG"
177 exit
179 --abort)
180 git rerere clear
181 if test -d "$dotest"
182 then
183 rm -r "$dotest"
184 elif test -d .dotest
185 then
186 rm -r .dotest
187 else
188 die "No rebase in progress?"
190 git reset --hard ORIG_HEAD
191 exit
193 --onto)
194 test 2 -le "$#" || usage
195 newbase="$2"
196 shift
198 -M|-m|--m|--me|--mer|--merg|--merge)
199 do_merge=t
201 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
202 --strateg=*|--strategy=*|\
203 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
204 case "$#,$1" in
205 *,*=*)
206 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
207 1,*)
208 usage ;;
210 strategy="$2"
211 shift ;;
212 esac
213 do_merge=t
215 -v|--verbose)
216 verbose=t
218 --whitespace=*)
219 git_am_opt="$git_am_opt $1"
221 -C*)
222 git_am_opt="$git_am_opt $1"
225 usage
228 break
230 esac
231 shift
232 done
234 # Make sure we do not have .dotest
235 if test -z "$do_merge"
236 then
237 if mkdir .dotest
238 then
239 rmdir .dotest
240 else
241 echo >&2 '
242 It seems that I cannot create a .dotest directory, and I wonder if you
243 are in the middle of patch application or another rebase. If that is not
244 the case, please rm -fr .dotest and run me again. I am stopping in case
245 you still have something valuable there.'
246 exit 1
248 else
249 if test -d "$dotest"
250 then
251 die "previous dotest directory $dotest still exists." \
252 'try git-rebase < --continue | --abort >'
256 # The tree must be really really clean.
257 git update-index --refresh || exit
258 diff=$(git diff-index --cached --name-status -r HEAD)
259 case "$diff" in
260 ?*) echo "cannot rebase: your index is not up-to-date"
261 echo "$diff"
262 exit 1
264 esac
266 # The upstream head must be given. Make sure it is valid.
267 upstream_name="$1"
268 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
269 die "invalid upstream $upstream_name"
271 # Make sure the branch to rebase onto is valid.
272 onto_name=${newbase-"$upstream_name"}
273 onto=$(git rev-parse --verify "${onto_name}^0") || exit
275 # If a hook exists, give it a chance to interrupt
276 if test -x "$GIT_DIR/hooks/pre-rebase"
277 then
278 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
279 echo >&2 "The pre-rebase hook refused to rebase."
280 exit 1
284 # If the branch to rebase is given, first switch to it.
285 case "$#" in
287 branch_name="$2"
288 git-checkout "$2" || usage
291 if branch_name=`git symbolic-ref -q HEAD`
292 then
293 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
294 else
295 branch_name=HEAD ;# detached
298 esac
299 branch=$(git rev-parse --verify "${branch_name}^0") || exit
301 # Now we are rebasing commits $upstream..$branch on top of $onto
303 # Check if we are already based on $onto with linear history,
304 # but this should be done only when upstream and onto are the same.
305 mb=$(git merge-base "$onto" "$branch")
306 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
307 # linear history?
308 ! git rev-list --parents "$onto".."$branch" | grep " .* " > /dev/null
309 then
310 echo >&2 "Current branch $branch_name is up to date."
311 exit 0
314 if test -n "$verbose"
315 then
316 echo "Changes from $mb to $onto:"
317 # We want color (if set), but no pager
318 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
321 # Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
322 echo "First, rewinding head to replay your work on top of it..."
323 git-reset --hard "$onto"
325 # If the $onto is a proper descendant of the tip of the branch, then
326 # we just fast forwarded.
327 if test "$mb" = "$branch"
328 then
329 echo >&2 "Fast-forwarded $branch_name to $onto_name."
330 exit 0
333 if test -z "$do_merge"
334 then
335 git format-patch -k --stdout --full-index --ignore-if-in-upstream "$upstream"..ORIG_HEAD |
336 git am $git_am_opt --binary -3 -k --resolvemsg="$RESOLVEMSG"
337 exit $?
340 # start doing a rebase with git-merge
341 # this is rename-aware if the recursive (default) strategy is used
343 mkdir -p "$dotest"
344 echo "$onto" > "$dotest/onto"
345 echo "$onto_name" > "$dotest/onto_name"
346 prev_head=`git rev-parse HEAD^0`
347 echo "$prev_head" > "$dotest/prev_head"
349 msgnum=0
350 for cmt in `git rev-list --reverse --no-merges "$upstream"..ORIG_HEAD`
352 msgnum=$(($msgnum + 1))
353 echo "$cmt" > "$dotest/cmt.$msgnum"
354 done
356 echo 1 >"$dotest/msgnum"
357 echo $msgnum >"$dotest/end"
359 end=$msgnum
360 msgnum=1
362 while test "$msgnum" -le "$end"
364 call_merge "$msgnum"
365 continue_merge
366 done
368 finish_rb_merge